1. 每个API都配有中文、英文两种使用方法，开发者可根据自己喜好随意选择
2. 每个API都配备了详细的开发文档以及视频形式的讲解，以确保开发者可以完全学会使用
3. 除插件的开发文档外，我们集成了常用工具、公开课、AS-FAQ等多项功能，让开发者从此告别东拼西凑
   文档地址：https://www.yuque.com/xianle-skqwj/ld


# 升级日志：

## 1.1.9
- 统一点击函数名称
- 修复获取_全部元素查找失败返回None问题
- 新增获取_设备版本方法
- 新增循环执行方法函数
- 修复重复使用查询全部元素可能失败问题
- 修复链式操作等待失效的问题
- 增加点击函数持续时间参数
- 修复在循环中链式操作逻辑错误问题

## 1.1.8

- 新增谷歌OCR识别，该函数是调用官网的谷歌OCR，可能程序会崩溃
```python
elements = {
    "任务": {
        "OCR_Mlkit": OcrQuery().mlkitocr_v2().text("系统应用").rect_center()
    }
}
ld.元素_操作("任务1", "OCR_Mlkit").点击_坐标().执行()

# 此外也可以直接识别屏幕某个区域文字
print(ld.文字识别_MlkitV2([85, 1088, 250, 1142]))
```

- `点击`、`滑动`相关函数支持百分比坐标
```python

# 直接使用如下
ld.滑动(["50%", "40%"], ["50%", "60%"])

ld.点击_坐标("50%", "50%")

# 也可以在链式中使用，滑动一样，这里不再过多演示
ld.元素_操作("任务1", "找图_游戏中心").点击_坐标("50%", "50%").随机_延迟(2).执行()
```

## 1.1.7
- 修复`元素_等待`函数失效问题

## 1.1.6
- 新增找图/找色/找字支持屏幕区域，以下以找图为例：
```python
elements = {
    "任务1": {
        "找图_游戏中心": ImageQuery().find().img("yxzx.png").rect_center()
    },
}
# 以上的rect_center()代表找屏幕中心位置，除此之外还支持
# rect_left_top() - 获取右上角范围
# rect_left_top() - 获取左上角范围
# rect_left_bottom() - 获取左下角范围
# rect_right_bottom() - 获取右下角范围
# rect_half_left() - 获取左半屏范围
# rect_half_right() - 获取右半屏范围
# rect_half_top() - 获取上半屏范围
# rect_half_bottom() - 获取下半屏范围
```

## 1.1.5
- 新增统计运行时间日志
```python
# 只需要设置系统日志级别即可
ld.日志_设置级别(LogLevel.INFO)
```
- 新增随机延迟函数
```python
 ld.随机_延迟(second, float_tame)
```
- 新增设备相关函数
```python
ld.获取_设备ID()
ld.获取_设备名称()
ld.获取_设备屏幕信息()
ld.获取_设备品牌()
ld.获取_设备型号()
ld.获取_设备SDK()
ld.获取_设备IP()
ld.获取_当前运行APP信息()
ld.获取_所有安装APP()
ld.获取_当前电量()
ld.获取_设备内存()
```

## 1.1.4
- 新增找图函数可以增加多图片
```python
elements = {
    "测试任务": {
        "多图测试": ImageQuery().find_template().img("小工具-谷歌安装器.png", "小工具-RE文件管理器.png",
                                                     "小工具-主题装扮.png"),
    }
}
```


- 新增字符串函数可以统计字符出现个数

```python
print(文本.字符出现次数("abcabcabc", "ab"))
```

### 升级方法
1.AS当中引用代码为：

```python
plug.load("ld:1.1.4")
```
2.更新提示包插件：

```bash
pip install --upgrade ld-as-framework
```